#!/usr/bin/perl
+=comment
+
+Copyright (c) 2003-2010, Andrew Dunstan
+
+See accompanying License file for license details
+
+=cut
+
use strict;
+use vars qw($dbhost $dbname $dbuser $dbpass $dbport
+ $all_stat $fail_stat $change_stat $green_stat
+ $server_time
+ $min_script_version $min_web_script_version
+ $default_host
+);
+
+# force this before we do anything - even load modules
+BEGIN { $server_time = time; }
+
use CGI;
use Digest::SHA1 qw(sha1_hex);
use MIME::Base64;
use DBD::Pg;
use Data::Dumper;
use Mail::Send;
-use Safe;
-
-use vars qw($dbhost $dbname $dbuser $dbpass $dbport
- $all_stat $fail_stat $change_stat $green_stat
-);
+use Time::ParseDate;
+use Storable qw(thaw);
require "$ENV{BFConfDir}/BuildFarmWeb.pl";
+my $buildlogs = "$ENV{BFConfDir}/buildlogs";
die "no dbname" unless $dbname;
die "no dbuser" unless $dbuser;
my $changed_since_success = $query->param('changed_since_success');
my $changed_this_run = $query->param('changed_files');
my $log_archive = $query->param('logtar');
+my $frozen_sconf = $query->param('frozen_sconf') || '';
my $content =
"branch=$branch&res=$res&stage=$stage&animal=$animal&".
}
+unless ($branch =~ /^(HEAD|REL\d+_\d+_STABLE)$/)
+{
+ print
+ "Status: 492 bad branch parameter $branch\nContent-Type: text/plain\n\n",
+ "bad branch parameter $branch\n";
+ exit;
+
+}
+
my $db = DBI->connect($dsn,$dbuser,$dbpass);
my ($secret)=$sth->fetchrow_array();
$sth->finish;
+my $tsdiff = time - $ts;
+
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($ts);
$year += 1900; $mon +=1;
my $date=
sprintf("%d-%.2d-%.2d_%.2d:%.2d:%.2d",$year,$mon,$mday,$hour,$min,$sec);
-if ($ENV{BF_DEBUG} || ($ts > time) || (! $secret) )
+if ($ENV{BF_DEBUG} || ($ts > time) || ($ts + 86400 < time ) || (! $secret) )
{
- open(TX,">../buildlogs/$animal.$date");
+ open(TX,">$buildlogs/$animal.$date");
print TX "sig=$sig\nlogtar-len=" , length($log_archive),
"\nstatus=$res\nstage=$stage\nconf:\n$conf\n",
+ "tsdiff:$tsdiff\n",
"changed_this_run:\n$changed_this_run\n",
"changed_since_success:\n$changed_since_success\n",
+ "frozen_sconf:$frozen_sconf\n",
"log:\n",$log;
# $query->save(\*TX);
close(TX);
}
-unless ($ts < time)
+unless ($ts < time + 120)
{
my $gmt = gmtime($ts);
print "Status: 491 bad ts parameter - $ts ($gmt GMT) is in the future.\n",
- "Context-Type: text/plain\n\n bad ts parameter - $ts ($gmt GMT) is in the future\n";
+ "Content-Type: text/plain\n\n bad ts parameter - $ts ($gmt GMT) is in the future\n";
$db->disconnect;
exit;
}
+unless ($ts + 86400 > time)
+{
+ my $gmt = gmtime($ts);
+ print "Status: 491 bad ts parameter - $ts ($gmt GMT) is more than 24 hours ago.\n",
+ "Content-Type: text/plain\n\n bad ts parameter - $ts ($gmt GMT) is more than 24 hours ago.\n";
+ $db->disconnect;
+ exit;
+}
+
unless ($secret)
{
print
# undo escape-proofing of base64 data and decode it
map {tr/$@/+=/; $_ = decode_base64($_); }
- ($log, $conf,$changed_this_run,$changed_since_success,$log_archive);
+ ($log, $conf,$changed_this_run,$changed_since_success,$log_archive, $frozen_sconf);
+
+if ($log =~/Last file mtime in snapshot: (.*)/)
+{
+ my $snaptime = parsedate($1);
+ if ($snaptime < (time - (10 * 86400)))
+ {
+ print "Status: 493 snapshot too old: $1\nContent-Type: text/plain\n\n";
+ print "snapshot to old: $1\n";
+ $db->disconnect;
+ exit;
+ }
+}
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($ts);
$year += 1900; $mon +=1;
my $log_file_names;
my @log_file_names;
-my $dirname = "../buildlogs/tmp.$$.unpacklogs";
+my $dirname = "$buildlogs/tmp.$$.unpacklogs";
+
+my $githeadref;
if ($log_archive)
{
my $log_handle;
- my $archname = "../buildlogs/tmp.$$.tgz";
+ my $archname = "$buildlogs/tmp.$$.tgz";
open($log_handle,">$archname");
binmode $log_handle;
print $log_handle $log_archive;
mkdir $dirname;
@log_file_names = `tar -z -C $dirname -xvf $archname 2>/dev/null`;
map {s/\s+//g; } @log_file_names;
- my @qnames = @log_file_names;
+ my @qnames = grep { $_ ne 'githead.log' } @log_file_names;
map { $_ = qq("$_"); } @qnames;
$log_file_names = '{' . join(',',@qnames) . '}';
+ if (-e "$dirname/githead.log" )
+ {
+ open(my $githead,"$dirname/githead.log");
+ $githeadref = <$githead>;
+ chomp $githeadref;
+ close $githead;
+ }
# unlink $archname;
}
my $config_flags;
-my $container = new Safe;
-my $sconf = $conf;
-unless ($sconf =~ s/.*(\$Script_Config)/$1/ms )
+my $client_conf;
+if ($frozen_sconf)
+{
+ $client_conf = thaw $frozen_sconf;
+}
+
+if ($min_script_version)
+{
+ $client_conf->{script_version} ||= '0.0';
+ my $cli_ver = $client_conf->{script_version} ;
+ $cli_ver =~ s/^REL_//;
+ my ($minmajor,$minminor) = split(/\./,$min_script_version);
+ my ($smajor,$sminor) = split(/\./,$cli_ver);
+ if ($minmajor > $smajor || ($minmajor == $smajor && $minminor > $sminor))
+ {
+ print "Status: 460 script version too low\nContent-Type: text/plain\n\n";
+ print
+ "Script version is below minimum required\n",
+ "Reported version: $client_conf->{script_version},",
+ "Minumum version required: $min_script_version\n";
+ $db->disconnect;
+ exit;
+ }
+}
+
+if ($min_web_script_version)
+{
+ $client_conf->{web_script_version} ||= '0.0';
+ my $cli_ver = $client_conf->{web_script_version} ;
+ $cli_ver =~ s/^REL_//;
+ my ($minmajor,$minminor) = split(/\./,$min_web_script_version);
+ my ($smajor,$sminor) = split(/\./,$cli_ver);
+ if ($minmajor > $smajor || ($minmajor == $smajor && $minminor > $sminor))
+ {
+ print "Status: 461 web script version too low\nContent-Type: text/plain\n\n";
+ print
+ "Web Script version is below minimum required\n",
+ "Reported version: $client_conf->{web_script_version}, ",
+ "Minumum version required: $min_web_script_version\n"
+ ;
+ $db->disconnect;
+ exit;
+ }
+}
+
+my @config_flags;
+if (not exists $client_conf->{config_opts} )
{
- $sconf = '$Script_Config={};';
+ @config_flags = ();
+}
+elsif (ref $client_conf->{config_opts} eq 'HASH')
+{
+ # leave out keys with false values
+ @config_flags = grep { $client_conf->{config_opts}->{$_} }
+ keys %{$client_conf->{config_opts}};
+}
+elsif (ref $client_conf->{config_opts} eq 'ARRAY' )
+{
+ @config_flags = @{$client_conf->{config_opts}};
}
-my $client_conf = $container->reval("$sconf;");
-my @config_flags = @{ $client_conf->{config_opts} || [] };
if (@config_flags)
{
@config_flags = grep {! m/=/ } @config_flags;
map {s/\s+//g; $_=qq("$_"); } @config_flags;
+ push @config_flags,'git' if $client_conf->{scm} eq 'git';
$config_flags = '{' . join(',',@config_flags) . '}' ;
}
+my $scm = $client_conf->{scm} || 'cvs';
+my $scmurl = $client_conf->{scm_url};
my $logst = <<EOSQL;
insert into build_status
(sysname, snapshot,status, stage, log,conf_sum, branch,
changed_this_run, changed_since_success,
- log_archive_filenames , log_archive, build_flags)
- values(?,?,?,?,?,?,?,?,?,?,?,?)
+ log_archive_filenames , log_archive, build_flags, scm, scmurl,
+ git_head_ref,frozen_conf)
+ values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)
EOSQL
;
+
+
+# this transaction lets us set log_error_verbosity to terse
+# just for the duration of the transaction. That turns off logging the
+# bind params, so all the logs don't get stuffed on the postgres logs
+
+$db->begin_work;
+$db->do("select set_local_error_terse()");
+
+
$sth=$db->prepare($logst);
$sth->bind_param(1,$animal);
$sth->bind_param(8,$changed_this_run);
$sth->bind_param(9,$changed_since_success);
$sth->bind_param(10,$log_file_names);
-$sth->bind_param(11,$log_archive,{ pg_type => DBD::Pg::PG_BYTEA });
+#$sth->bind_param(11,$log_archive,{ pg_type => DBD::Pg::PG_BYTEA });
+$sth->bind_param(11,undef,{ pg_type => DBD::Pg::PG_BYTEA });
$sth->bind_param(12,$config_flags);
+$sth->bind_param(13,$scm);
+$sth->bind_param(14,$scmurl);
+$sth->bind_param(15,$githeadref);
+$sth->bind_param(16,$frozen_sconf,{ pg_type => DBD::Pg::PG_BYTEA });
$sth->execute;
$sth->finish;
+
+
my $logst2 = <<EOSQL;
insert into build_status_log
foreach my $log_file( @log_file_names )
{
- my $handle;
- open($handle,"$dirname/$log_file");
- my $mtime = (stat $handle)[9];
- my $stage_interval = $mtime - $stage_start;
- $stage_start = $mtime;
- my $ltext = <$handle>;
- close($handle);
- $sth->execute($animal,$dbdate,$branch,$log_file,$ltext,
- "$stage_interval seconds");
+ next if $log_file =~ /^githead/;
+ my $handle;
+ open($handle,"$dirname/$log_file");
+ my $mtime = (stat $handle)[9];
+ my $stage_interval = $mtime - $stage_start;
+ $stage_start = $mtime;
+ my $ltext = <$handle>;
+ close($handle);
+ $ltext =~ s/\x00/\\0/g;
+ $sth->execute($animal,$dbdate,$branch,$log_file,$ltext,
+ "$stage_interval seconds");
}
-
$sth->finish;
+$db->commit;
+
my $prevst = <<EOSQL;
select coalesce((select distinct on (snapshot) stage
my ($os, $compiler,$arch) = @$row;
$sth->finish;
+$db->begin_work;
+# prevent occasional duplication by forcing serialization of this operation
+$db->do("lock table dashboard_mat in share row exclusive mode");
+$db->do("delete from dashboard_mat");
+$db->do("insert into dashboard_mat select * from dashboard_mat_data");
+$db->commit;
+
$db->disconnect;
print "Content-Type: text/plain\n\n";
if ($ENV{BF_DEBUG})
{
- open(TX,">>../buildlogs/$animal.$date");
+ my $client_time = $client_conf->{current_ts};
+ open(TX,">>$buildlogs/$animal.$date");
print TX "\n",Dumper(\$client_conf),"\n";
+ print TX "server time: $server_time, client time: $client_time\n" if $client_time;
close(TX);
}
my $mailto = [@$all_stat];
push(@$mailto,@$fail_stat) if $stage ne 'OK';
-my $me = `id -un`; chomp $me;
+my $me = `id -un`; chomp($me);
+
+my $host = `hostname`; chomp ($host);
+$host = $default_host unless ($host =~ m/[.]/ || !defined($default_host));
-my $host = `hostname`; chomp $host;
+my $from_addr = "PG Build Farm <$me\@$host>";
+$from_addr =~ tr /\r\n//d;
my $msg = new Mail::Send;
-$msg->set('From',"PG Build Farm <$me\@$host>");
$msg->to(@$mailto);
$msg->bcc(@$bcc_stat) if (@$bcc_stat);
$msg->subject("PGBuildfarm member $animal Branch $branch $stat_type $stage");
+$msg->set('From',$from_addr);
my $fh = $msg->open;
print $fh <<EOMAIL;
$msg = new Mail::Send;
-$msg->set('From',"PG Build Farm <$me\@$host>");
$msg->to(@$mailto);
$msg->bcc(@$bcc_chg) if (@$bcc_chg);
$stat_type .= " failure" if $stage ne 'OK';
$msg->subject("PGBuildfarm member $animal Branch $branch Status $stat_type");
+$msg->set('From',$from_addr);
$fh = $msg->open;
print $fh <<EOMAIL;